#include "predef.h" 
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <..\mod5282\system\sim5282.h>
#include <cfinter.h>


extern "C" { 
void UserMain(void * pd);
extern const unsigned long CPU_CLOCK;
void SetIntc( int intc, long func, int vector, int level, int prio );
}

const char * AppName="bare_serial";



volatile uartstruct *BareUart;


volatile DWORD nCharCount;





INTERRUPT( BARE_ISR, 0x2400 )
{
while (BareUart->usr & 1)
	{//Process incomming chars */
	 char c = ( BareUart->udb ); 
	 /* Do watever you want with the chars, for this example we will just count and set leds*/
	 nCharCount++;
	 putleds(c);
	}

}




void OpenBareSerial(int port, unsigned long baud)
{

BareUart = &sim.uarts[port];

unsigned char ub1 = 0;
unsigned char ub2 = 0x41;

/* Calculate baud rate */
DWORD hdiv = ( ( ( CPU_CLOCK / 16 ) / baud ) + 1 ) >> 1;
ub1 = ( hdiv >> 8 ) & 0xFF;
ub2 = ( hdiv & 0xFF );

BareUart->ucr =  0x2a; /*Reset Rx Transmit disable Rx disable */
BareUart->ucr =  0x3a;    /*Reset Tx Transmit disable Rx disable */
BareUart->ucr =  0x1a;/*Transmit disable Rx disable reset mode reg */

BareUart->ucr =  0x10;
BareUart->umr =  0x13; /* umr1 8 data bits no parity */
BareUart->umr =  0x27;  /* umr2 1 stop*/ 

BareUart->usr =  0xDD; /* Use the internal timer for Baud Rate Generation */
BareUart->iacr = 0x00; 
BareUart->ir =   0x02;  /*Enable Rx  interrupts */

BareUart->dur = ub1; /* Actualy set the baud rate we calculated */
BareUart->dlr = ub2;


switch (port) /* Set up the hardware ports */
{
case 0:
	SetIntc( 0, ( unsigned long ) & BARE_ISR, 13, 3, 1 );    
    sim.gpio.puapar |= 0x03; /* 0000 0011 UM 26.3.2.15*/
    break;

case 1:
	SetIntc( 0, ( unsigned long ) & BARE_ISR, 14, 3, 2 );
	sim.gpio.puapar |= 0x0C; /*0000 1100 UM 26.3.2.15*/
	break;
case 2:
	{
	 WORD paspar = sim.gpio.paspar;
	 if ( ( paspar & 3 ) == 2 )
	 {
		 paspar &= 0xFFFC;
	 }
	 if ( ( paspar & 6 ) == 4 )
	 {
		 paspar &= 0xFFF3;
	 }
	 /* Third serial on CAN pins */
	 paspar &= 0xF0F; /* 0000 0000 1010 0000  UM 26.3.2.10*/ 
	 paspar |= 0xA0; /* 0000 0000 1010 0000  UM 26.3.2.10*/ 
     sim.gpio.paspar = paspar;
	 SetIntc( 0, ( unsigned long ) & BARE_ISR, 15, 3, 3 );


    }
	break;
}//End of switch


BareUart->ucr = 0x05;/*Enable Tx and Rx */ 
}


void NoIsrWriteChar(int port, char c)
{
 while ( ( sim.uarts[port].usr & 4 ) == 0 ); 
 sim.uarts[port].udb = ( unsigned char ) c;  
}





void UserMain(void * pd)
{
   InitializeStack();
   if (EthernetIP == 0) GetDHCPAddress(); 
   OSChangePrio(MAIN_PRIO);
   EnableAutoUpdate();

   OpenBareSerial(1,115200);

   iprintf("Application started\n");
   while (1)
  {
	OSTimeDly(20);
	iprintf("Count = %ld\r\n",nCharCount);

  }
}
